function U = OrderComponents(U, U_First)

N = size(U, 2);

% Find normalized components
U_Norm = zeros(size(U));
U_First_Norm = zeros(size(U));
for i = 1:N
   U_Norm(:, i) = U(:, i) / norm(U(:, i));
   U_First_Norm(:, i) = U_First(:, i) / norm(U_First(:, i));
end

% Order components
for i = 1:N
   % Find component with max covariance with i-th first component
   MaxVal = abs(dot(U_Norm(:, i), U_First_Norm(:, 1)));
   MaxIndex = 1;
   for j = 2:N
      if abs(dot(U_Norm(:, i), U_First_Norm(:, j))) > abs(MaxVal)
         MaxVal = dot(U_Norm(:, i), U_First_Norm(:, j));
         MaxIndex = j;
      end
   end
   % Swap max component into correct position
   Temp = U(:, i);
   U(:, i) = U(:, MaxIndex);
   U(:, MaxIndex) = Temp;
   %if MaxVal < 0
   %   U(:, i) = - U(:, i);
   %end
   
   Temp = U_Norm(:, i);
   U_Norm(:, i) = U_Norm(:, MaxIndex);
   U_Norm(:, MaxIndex) = Temp;
   %if MaxVal < 0
   %   U_Norm(:, i) = - U_Norm(:, i);
   %end
end
for i = 1:N
   if	dot(U(:, i), U_First(:, i)) < 0
      U(:, i) = -U(:, i);
   end
end

